/*******************************************************************/
/*                    AirCon     V1.0           21.3.2009          */
/*                                                                 */
/* Dies ist ein Diagnoseprogramm zur Kommunikation mit der         */
/* Klimasteuerung des Lancia Kappa ueber die KL-Line nach          */
/* ISO-9141                                                        */
/*                                                                 */
/* Nach dem starten sieht das Programm etwas armselig aus. Das     */
/* liegt daran das die eigentliche Funktionalitaet in den anderen  */
/* Fenstern versteckt ist die man ueber den Menue-Button unten     */
/* links neben dem Graffity-Feld anwaehlt.                         */
/* Die Anwahl der anderen Fenster ist aber nur moeglich wenn es    */
/* eine funktionierende Verbindung zum Steuergeraet gibt!          */
/*                                                                 */
/* Funktionsbeschreibung:                                          */
/* Nach dem start oeffnet das Programm die serielle Schnittstelle. */
/* Es wird dann darauf gewartet das der User den 'Connect'-Button  */
/* betaetigt. Dann wird versucht eine Verbindung mit dem           */
/* Steuergeraet aufzubauen. Gelingt dies so geht das Programm      */
/* in den Connectmodus ueber. Es ist dann moeglich die anderen     */
/* Fenster anzuwaehlen. Ausserdem findet dann 10x pro Sekunde ein  */
/* Datenaustausch mit dem Steuergeraet statt. Dabei werden         */
/* normalerweise nur ACK-Frames ausgetauscht. Dies ist notwendig   */
/* damit das Steuergeraet nicht von sich aus die Verbindung wieder */
/* abbricht.                                                       */
/* Wenn man in einem anderen Fenster als dem StartFenster ist, so  */
/* werden immer mal wieder Nutzdaten vom Steugeraet angefordert    */
/* und im Fenster dargestellt.                                     */
/*                                                                 */
/* Es ist sehr wichtig das es nirgendwo im Programm eine Stelle    */
/* gibt wo die Ausfuehrung fuer 0.1s oder laenger blockiert wird.  */
/* Passiert das so hat das Betriebsystem des Palms nicht mehr      */
/* genug Zeit um die Daten mit dem Steuergeraet auszutauschen.     */
/* In dem Falle wird die Verbindung vom Steuergeraet abgebrochen   */
/*                                                                 */
/* Normalerweise sind Palms sehr stromsparend. Mein alter Prof     */
/* laeuft mit Batterien mehrere Monate. Das gilt aber sicher nicht */
/* wenn man dieses Programm zu lange laufen laesst. Das liegt      */
/* daran das es dauernd mit dem Steuergeraet reden muss und die    */
/* RS232 nunmal Strom fuer ihren Pegelwandler braucht.             */
/*                                                                 */
/*                                                                 */
/* Das Programm ist nicht Public Domain! Jede kommerzielle Nutzung */
/* ist ausdruecklich untersagt!                                    */
/* Jede private Nutzung ist natuerlich erlaubt. Es gibt            */
/* selbstverstaendlich keine Garantien bezueglich der              */
/* Funktionsfaehigkeit. Es kann auch nicht ausgeschlossen werden   */
/* das man sich sein Steuergeraet zerstoert. Auch das ist dann     */
/* nicht mein Problem!                                             */
/* Nochmal ausdruecklich, jeder kommerzielle Nutzung, sei es in    */
/* Werkstaetten, als Beilage bei Zeitschriften, Anbietung zum      */
/* download auf Homepages, ist untersagt!                          */
/*                                                                 */
/* Getestet wurde das Programm mit einem 95er Lancia Kappa mit     */
/* 2.4l und Klimaautomatik. Bei erfolgreicher Nutzung mit anderen  */
/* Modellen, oder aber auch Problemen bitte eine Mail an mich.     */
/*                                                                 */
/* Ich habe das Programm auf einem alten Palmpilot Professional    */
/* entwickelt. Es wird sicherlich auch auf einem Palmpilot         */
/* Personal laufen.                                                */
/* Ich halte es auch fuer sehr wahrscheinlich das es auf PalmIII,  */
/* IBM Workpad, PalmIIIe, m100, IIIx, usw laufen wird              */
/* Wichtig fuer die Funktion ist eine serielle Schnittstelle im    */
/* Palmpilot mit zusaetzlicher RTS-Line. Deshalb werden            */
/* die Geraete von Handspring nicht gehen.                         */
/* Ausserdem vermute ich das neuere Palms die nicht auf dem        */
/* Motorola Dragonball basieren auch Probleme machen weil diese    */
/* die alte CPU nur emulieren und es Probleme mit dem Timing geben */
/* wird.                                                           */
/* Getestet ist es aber derzeit nur mit Palmpilot Professional     */
/* und einem PalmIIIx                                              */
/*                                                                 */
/* Meine Anleitung zum Bau eines Steckverbinders mit Pegelwandler  */
/* wird nur am Palm Personal und Palm Professional verwendbar sein.*/
/* Mittlerweile habe ich den Adapter aber auch am PalmIIIx         */
/* verwendet.                                                      */
/*                                                                 */
/* Die neueren Palms hatten leider andauernd einen neuen Stecker   */
/* Man muss sich daher dann selbst etwas basteln.                  */
/* Es waer auch denkbar die Schaltung mit normalen Bauteilen BC547 */
/* 1N4148 usw, auf Lochraster aufzubauen und an den Stecker eines  */
/* Craddles zu stecken wenn man kein SMD verarbeiten will.         */
/*                                                                 */
/* Derzeit unterstuetzt das Programm aussliesslich das Klima-      */
/* Steuergeraet. Natuerlich waere es nett wenn man auch das        */
/* Motorsteuergeraet auslesen koennte. Das ist grundsaetzlich kein */
/* grosses Problem. Es muesste mir nur jemand mal ein solches      */
/* Steuergeraet schenken weil ich keine Lust habe mit dem Laptop   */
/* in meinem Auto zu sitzen um das zu programmieren. .-)           */
/*                                                                 */
/*******************************************************************/
#pragma pack(2)
#define MAIN

/* Vom Palmpilot zur Verfuegung gestellte Funktionen */
#include <stdio.h>
#include <Pilot.h>
#include <Common.h>
#include <System/SysAll.h>
#include <System/SerialMgr.h>
#include <UI/UIAll.h>

/* Eigene Header */
#include "header.h"       /* Zur Uebergabe der ResourcenIDs */
#include "AirCon.h"
#include "rs232.h"
#include "KL_Line.h"


/*******************************************************************/
/* Prueft welcher Button gedrueckt wurde und fuert eine zugehoerige*/
/* Funktion aus                                                    */
/*******************************************************************/
int ButtonCheck(Word Button)
{ int i;
 char buffer[40];

   /* Nur zu Testzwecken */
   if (  Button == MainButtonTest)
   {
     kl_test();

   };

   if (  Button == MainButtonSend)
   {
     kl_Command_ReadStatus();

   };

   if (  Button == MainButtonAnswer)
   {
     if ( kl_CommREADY() == FALSE )
       {
	 WinDrawChars("Keine Antwort!",14,  10, 30);

       } 
     else
       {
	 WinDrawChars("Antwort!      ",14,  10, 30);

	 for (i=0; i<(AirCon.PayLoadFrame.Blocklen-2);i++)
	 {
	   sprintf(buffer,"Data%i:  %x  ",i,AirCon.PayLoadFrame.Parameter[i]);
  	   WinDrawChars(buffer,StrLen(buffer),  80, 20+(i*10));
	   
	 };
	 
       }

   };



   /* Es sollen die Fehler im Steuergeraet geloescht werden */
   if (  Button == F4ButtonClear)
   {
     kl_Command_ClearError();

   };


   /* Air1-Button im Paramater-Read Frame */
   if (  Button == F6B1 ) kl_Command_ReadParameter(PARAM_AIR1);
   /* Air2-Button im Paramater-Read Frame */
   if (  Button == F6B2 ) kl_Command_ReadParameter(PARAM_AIR2);
   /* Aussentemperatur-Button im Paramater-Read Frame */
   if (  Button == F6B3 ) kl_Command_ReadParameter(PARAM_EXAIR);
   /* Innentemperatur-Button im Paramater-Read Frame */
   if (  Button == F6B4 ) kl_Command_ReadParameter(PARAM_PASSAIR);
   /* Verteiler-Button im Paramater-Read Frame */
   if (  Button == F6B5 ) kl_Command_ReadParameter(PARAM_DISTPOT);
   /* Mischer-Button im Paramater-Read Frame */
   if (  Button == F6B6 ) kl_Command_ReadParameter(PARAM_MIXPOT);
   /* Luefter-Button im Paramater-Read Frame */
   if (  Button == F6B7 ) kl_Command_ReadParameter(PARAM_FAN);
   /* Geschwindigkeit-Button im Paramater-Read Frame */
   if (  Button == F6B8 ) kl_Command_ReadParameter(PARAM_SPEED);
   /* Sonnenlicht-Button im Paramater-Read Frame */
   if (  Button == F6B9 ) kl_Command_ReadParameter(PARAM_SUN);


   /*========== Actuator-Buttons ===================================*/
   if ( AirCon.Active_Diag == TRUE)
     {
       /* Wir koennen nur Kommandos absetzen wenn das Steuergeraet */
       /* auch im Active_Diag Modus ist!                           */

       /* Beeper einschalten */
       if (  Button == F7B1 ) kl_Command_Set_Actuator(ACTUATOR_BUZZER, 0x01);
       /* Beeper ausschalten */
       if (  Button == F7B2 ) kl_Command_Set_Actuator(ACTUATOR_BUZZER, 0x07);

       /* Lampe in Armaturenbrett einschalten */
       if (  Button == F7B3 ) kl_Command_Set_Actuator(ACTUATOR_LIGHT, 0x01);
       /* Lampe ausschalten  */
       if (  Button == F7B4 ) kl_Command_Set_Actuator(ACTUATOR_LIGHT, 0x07);


       /* Lueftermotor am Temperaturfuehler rechtslauf */
       if (  Button == F7B5 ) kl_Command_Set_Actuator(ACTUATOR_MOTOR, 0x00);
       /* Lueftermotor am Temperaturfuehler linkslauf  */
       if (  Button == F7B6 ) kl_Command_Set_Actuator(ACTUATOR_MOTOR, 0x01);
       /* Lueftermotor am Temperaturfuehler aus  */
       if (  Button == F7B7 ) kl_Command_Set_Actuator(ACTUATOR_MOTOR, 0x07);


       /* Luftmischer auf min */
       if (  Button == F7B8 ) kl_Command_Set_Actuator(ACTUATOR_MIXER, 0x02);
       /* Luftmischer auf med */
       if (  Button == F7B9 ) kl_Command_Set_Actuator(ACTUATOR_MIXER, 0x04);
       /* Luftmischer auf max */
       if (  Button == F7B10 ) kl_Command_Set_Actuator(ACTUATOR_MIXER, 0x06);
       /* Luftmischer auf off */
       if (  Button == F7B11 ) kl_Command_Set_Actuator(ACTUATOR_MIXER, 0x07);


       /* Verteiler auf Vent */
       if (  Button == F7B12 ) kl_Command_Set_Actuator(ACTUATOR_DIST, 0x02);
       /* Verteiler auf Bi-Level */
       if (  Button == F7B13 ) kl_Command_Set_Actuator(ACTUATOR_DIST, 0x03);
       /* Verteiler auf Floor */
       if (  Button == F7B14 ) kl_Command_Set_Actuator(ACTUATOR_DIST, 0x04);
       /* Verteiler auf Heat */
       if (  Button == F7B15 ) kl_Command_Set_Actuator(ACTUATOR_DIST, 0x05);
       /* Verteiler auf Defroster */
       if (  Button == F7B16 ) kl_Command_Set_Actuator(ACTUATOR_DIST, 0x06);
       /* Verteiler auf Off */
       if (  Button == F7B17 ) kl_Command_Set_Actuator(ACTUATOR_DIST, 0x07);


       /* Umluft einschalten */
       if (  Button == F7B18 ) kl_Command_Set_Actuator(ACTUATOR_CIRC, 0x00);
       /* Umluft ausschalten */
       if (  Button == F7B19 ) kl_Command_Set_Actuator(ACTUATOR_CIRC, 0x01);


       /* Luefter aus */
       if (  Button == F7B20 ) kl_Command_Set_Actuator(ACTUATOR_FAN, 0x00);
       /* Luefter auf 33% */
       if (  Button == F7B21 ) kl_Command_Set_Actuator(ACTUATOR_FAN, 0x55);
       /* Luefter auf 66% */
       if (  Button == F7B22 ) kl_Command_Set_Actuator(ACTUATOR_FAN, 0xaa);
       /* Luefter auf 100% */
       if (  Button == F7B23 ) kl_Command_Set_Actuator(ACTUATOR_FAN, 0xff);



     };
   /*===============================================================*/


   /*====================== Programm beenden?=======================*/
   if (  Button == MainButtonQuit)
   {
    CloseRS232();
    return (FALSE); /* Programm beenden */
   };
   /*===============================================================*/

   return(TRUE);
}

/*******************************************************************/
/* Zum beinflussen der Werte in Frames                             */
/* Also z.B um einen Haken in einem Radiobutton zu setzen          */
/*******************************************************************/
static void SetControl(unsigned short formID, unsigned short controlID, short value)
{
  FormPtr         frm;
  unsigned short          obj;
  ControlPtr ctl;
  
  frm = FrmGetFormPtr(formID);
  obj = FrmGetObjectIndex(frm, controlID);
  ctl = (ControlPtr)FrmGetObjectPtr(frm, obj);
  CtlSetValue (ctl, value);
}



/*******************************************************************/
/* Ausgabe von Status1 Fehlermeldungen in den Frame                */
/*******************************************************************/
void do_status1_test(unsigned short MyForm)
{ unsigned char switches;
  unsigned char ige;



  if (  (kl_CommREADY()==TRUE) && 
        (AirCon.PayLoadFrame.Title   == COMMAND_READ_STATUS )
     )
    {
      /* Status Switches auslesen = Byte1 */
      switches = AirCon.PayLoadFrame.Parameter[0];

      /* Bit0 = Bremsbelag */
      if (switches & 0x01) SetControl(MyForm,F2_CHK1,1);
      else SetControl(MyForm,F2_CHK1,0);

      /* Bit1 = Kuehlwasser */
      if (switches & 0x02) SetControl(MyForm,F2_CHK2,1);
      else SetControl(MyForm,F2_CHK2,0);

      /* Bit2 = Oelstand */
      if (switches & 0x04) SetControl(MyForm,F2_CHK3,1);
      else SetControl(MyForm,F2_CHK3,0);

      /* Bit3 = Wasser im Dieselfilter */
      if (switches & 0x08) SetControl(MyForm,F2_CHK4,1);
      else SetControl(MyForm,F2_CHK4,0);

      /* Bit4 = Ladedruck */
      if (switches & 0x10) SetControl(MyForm,F2_CHK5,1);
      else SetControl(MyForm,F2_CHK5,0);



      /* Status IGE  auslesen = Byte2 */
      ige = AirCon.PayLoadFrame.Parameter[1];

      /* Bit0 = Standlicht Vorne */
      if (ige & 0x01) SetControl(MyForm,F2_CHK6,1);
      else SetControl(MyForm,F2_CHK6,0);

      /* Bit1 = Standlicht hinten */
      if (ige & 0x02) SetControl(MyForm,F2_CHK7,1);
      else SetControl(MyForm,F2_CHK7,0);

      /* Bit2 = Nebelschlussleuchte */
      if (ige & 0x04) SetControl(MyForm,F2_CHK8,1);
      else SetControl(MyForm,F2_CHK8,0);

      /* Bit3 = Bremslicht */
      if (ige & 0x08) SetControl(MyForm,F2_CHK9,1);
      else SetControl(MyForm,F2_CHK9,0);

      /* Bit4 = Nummernschildbeleuchtung */
      if (ige & 0x10) SetControl(MyForm,F2_CHK10,1);
      else SetControl(MyForm,F2_CHK10,0);

      /* Bit6 = Sicherung Bremslicht */
      if (ige & 0x40) SetControl(MyForm,F2_CHK11,1);
      else SetControl(MyForm,F2_CHK11,0);


      
      /* Schonmal ein neuen Datensatz anfordern */	   
      kl_Command_ReadStatus();
    }
    else kl_Command_ReadStatus();



}


/*******************************************************************/
/* Ausgabe von Status2 Fehlermeldungen in den Frame                */
/*******************************************************************/
void do_status2_test(unsigned short MyForm)
{ unsigned char door;
  unsigned char alarm;



  if (  (kl_CommREADY()==TRUE) && 
        (AirCon.PayLoadFrame.Title   == COMMAND_READ_STATUS )
     )
    {
      /* Status Switches auslesen = Byte3 */
      door = AirCon.PayLoadFrame.Parameter[2];

      /* Bit0 = Tuer vorne rechts */
      if (door & 0x01) SetControl(MyForm,F3_CHK1,1);
      else SetControl(MyForm,F3_CHK1,0);

      /* Bit1 = Tuer vorne links */
      if (door & 0x02) SetControl(MyForm,F3_CHK2,1);
      else SetControl(MyForm,F3_CHK2,0);

      /* Bit2 = Tuer hinten rechts */
      if (door & 0x04) SetControl(MyForm,F3_CHK3,1);
      else SetControl(MyForm,F3_CHK3,0);

      /* Bit3 = Tuer hinten links */
      if (door & 0x08) SetControl(MyForm,F3_CHK4,1);
      else SetControl(MyForm,F3_CHK4,0);

      /* Bit4 = Kofferraum */
      if (door & 0x10) SetControl(MyForm,F3_CHK5,1);
      else SetControl(MyForm,F3_CHK5,0);



      /* Status Alarme  auslesen = Byte4 */
      alarm = AirCon.PayLoadFrame.Parameter[3];

      /* Bit0 = Automatic Getriebeoeltemperatur */
      if (alarm & 0x01) SetControl(MyForm,F3_CHK6,1);
      else SetControl(MyForm,F3_CHK6,0);

      /* Bit1 = Automaticgetriebe */
      if (alarm & 0x02) SetControl(MyForm,F3_CHK7,1);
      else SetControl(MyForm,F3_CHK7,0);

      /* Bit5 = Motosteuerung */
      if (alarm & 0x20) SetControl(MyForm,F3_CHK8,1);
      else SetControl(MyForm,F3_CHK8,0);

      /* Bit6 = Katalysator zu heiss */
      if (alarm & 0x40) SetControl(MyForm,F3_CHK9,1);
      else SetControl(MyForm,F3_CHK9,0);

      /* Bit7 = Aufhaengung */
      if (alarm & 0x80) SetControl(MyForm,F3_CHK10,1);
      else SetControl(MyForm,F3_CHK10,0);

      
      /* Schonmal ein neuen Datensatz anfordern */	   
      kl_Command_ReadStatus();
    }
    else kl_Command_ReadStatus();



}

/*******************************************************************/
/* Umsetzung der Fehlerbytes vom Steuergeraet in Humanreadable     */
/*******************************************************************/
void Error_to_Ascii(unsigned char Faulty, unsigned char Counter, 
		    char Chr_Error[], 
		    char Chr_Count[], 
		    char Chr_Type[])
{

  /* Fehlerart umwandeln */
  switch (Faulty & 0x07)
    {
    case 0x01:
      StrCopy(Chr_Type,"Eingang offen");
      break;
    case 0x02:
      StrCopy(Chr_Type,"Masseschluss");
      break;
    case 0x03:
      StrCopy(Chr_Type,"12V am Anschluss");
      break;
    case 0x04:
      StrCopy(Chr_Type,"Fehler!");
      break;

    default:
      StrCopy(Chr_Type,"Unbekannt!");
      break;

    }

  /* Fehleranzahl umwandeln */
  StrIToA(Chr_Count, Counter);

  /* Fehlerbezeichnung umwandeln */
  switch ( Faulty & 0xf8)
    {
    case TREAT_AIR_TEMP1:
      StrCopy(Chr_Error,"Lufttemperatur Sensor1");
      break;

    case TREAT_AIR_TEMP2:
      StrCopy(Chr_Error,"Lufttemperatur Sensor2");
      break;

    case EXT_TEMP_SENSOR:
      StrCopy(Chr_Error,"Externe Lufttemperatur");
      break;

    case PASS_COMP_TEMP:
      StrCopy(Chr_Error,"Innenraumtemperatur");
      break;

    case AIR_MIX_ACT:
      StrCopy(Chr_Error,"Luftmischer");
      break;

    case AIR_DIST_ACT:
      StrCopy(Chr_Error,"Luftverteiler");
      break;

    case INT_FAN:
      StrCopy(Chr_Error,"Lueftermotor");
      break;

    case MIX_ACT_FEEDBACK:
      StrCopy(Chr_Error,"Position Luftmischer");
      break;

    case DIST_ACT_FEEDBACK:
      StrCopy(Chr_Error,"Position Luftverteiler");
      break;

    case PASS_COMP_SEN_FAN:
      StrCopy(Chr_Error,"Temp-Sensor Ventilator");
      break;

    case COMPRESS_CONTROL:
      StrCopy(Chr_Error,"Kompressorsteuerung");
      break;

    case SUN_SENSOR:
      StrCopy(Chr_Error,"Sensor Sonnenlicht");
      break;

    case AIR_RECIRC:
      StrCopy(Chr_Error,"Umluftklappe");
      break;

    case IGE_FPLAMP:
      StrCopy(Chr_Error,"Positionslicht vorne");
      break;

    case IGE_RPLAMP:
      StrCopy(Chr_Error,"Positionslicht hinten");
      break;

    case IGE_RFLAMP:
      StrCopy(Chr_Error,"Nebeschlussleuchte");
      break;

    case IGE_STOPLAMP:
      StrCopy(Chr_Error,"Bremslicht");
      break;

    case IGE_PLATELAMP:
      StrCopy(Chr_Error,"Nummernschildleuchte");
      break;

    case IGE_STOPFUSE:
      StrCopy(Chr_Error,"Bremslicht Sicherung");
      break;

    case ENGINE_OIL:
      StrCopy(Chr_Error,"Oelstandssensor");
      break;

    case REAR_GLASS:
      StrCopy(Chr_Error,"Heckscheibenheizung");
      break;

    case EMERGENCY_LIGHT:
      StrCopy(Chr_Error,"Warnblinklicht");
      break;

    case MOTRONIC:
      StrCopy(Chr_Error,"Motorelektronik");
      break;

    case RPM_SIGNAL:
      StrCopy(Chr_Error,"Drehzahleingang");
      break;

    default:
      StrCopy(Chr_Error,"Unbekannt!");
      break;


    };
}


/*******************************************************************/
/* Ausgabe von ASCII-Text in ein FIELD im Form                     */
/*******************************************************************/
static FieldPtr SetField(unsigned short formID, 
			 unsigned short fieldID, 
			 char str[])
{
  FormPtr         frm;
  FieldPtr        fld;
  unsigned short          obj;
  CharPtr         p;
  VoidHand        h;

  frm = FrmGetFormPtr(formID);
  obj = FrmGetObjectIndex(frm, fieldID);
  fld = (FieldPtr)FrmGetObjectPtr(frm, obj);
  h = (VoidHand)FldGetTextHandle(fld);
  if (h == NULL)
      {
	h = MemHandleNew (FldGetMaxChars(fld)+1);
	ErrFatalDisplayIf(!h, "No Memory");
      }

  p = (CharPtr)MemHandleLock(h);
  StrCopy(p, str);
  MemHandleUnlock(h);

  FldSetTextHandle(fld, (Handle)h);
}


/*******************************************************************/
/* Ausgabe des Fehlerspeiches in Frame                             */
/*******************************************************************/
void do_error_show(unsigned short MyForm)
{ unsigned char Faulty;
  unsigned char Counter;

  char Chr_Error[40];
  char Chr_Count[10];
  char Chr_Type[30];

  /*
      SetField(MyForm, F4_FI4 , "Test123");

      sprintf(Chr_Error,"Title: %i",AirCon.PayLoadFrame.Title);
      SetField(MyForm, F4_FI7 , Chr_Error);


      sprintf(Chr_Error,"Error: %i",AirCon.PayLoadFrame.Error);
      SetField(MyForm, F4_FI10 , Chr_Error);

      sprintf(Chr_Error,"Payload: %i",AirCon.PayLoad);
      SetField(MyForm, F4_FI13 , Chr_Error);

      sprintf(Chr_Error,"Laenge: %i",AirCon.PayLoadFrame.Blocklen);
      SetField(MyForm, F4_FI16 , Chr_Error);


      FrmDrawForm(FrmGetFormPtr(MyForm));

*/

  if (  (kl_CommREADY()==TRUE) && 
        (AirCon.PayLoadFrame.Title   == COMMAND_READ_ERROR )
     )
    {
      /* Fehlerspeicher1 auslesen = Byte0 */
      Faulty  = AirCon.PayLoadFrame.Parameter[0];
      /* ErrorCounter1 auslesen = Byte1 */
      Counter = AirCon.PayLoadFrame.Parameter[1];

      /* Fehler in ASCII-Text umwandeln */
      Error_to_Ascii(Faulty, Counter, Chr_Error, Chr_Count, Chr_Type);

      SetField(MyForm, F4_FI1 , Chr_Error);
      SetField(MyForm, F4_FI2 , Chr_Count);
      SetField(MyForm, F4_FI3 , Chr_Type);

      /* Fehlerspeicher2 auslesen = Byte2 */
      Faulty  = AirCon.PayLoadFrame.Parameter[2];
      /* ErrorCounter2 auslesen = Byte3 */
      Counter = AirCon.PayLoadFrame.Parameter[3];

      /* Fehler in ASCII-Text umwandeln */
      Error_to_Ascii(Faulty, Counter, Chr_Error, Chr_Count, Chr_Type);

      SetField(MyForm, F4_FI4 , Chr_Error);
      SetField(MyForm, F4_FI5 , Chr_Count);
      SetField(MyForm, F4_FI6 , Chr_Type);

      /* Fehlerspeicher3 auslesen = Byte4 */
      Faulty  = AirCon.PayLoadFrame.Parameter[4];
      /* ErrorCounter3 auslesen = Byte5 */
      Counter = AirCon.PayLoadFrame.Parameter[5];

      /* Fehler in ASCII-Text umwandeln */
      Error_to_Ascii(Faulty, Counter, Chr_Error, Chr_Count, Chr_Type);

      SetField(MyForm, F4_FI7 , Chr_Error);
      SetField(MyForm, F4_FI8 , Chr_Count);
      SetField(MyForm, F4_FI9 , Chr_Type);

      /* Fehlerspeicher4 auslesen = Byte6 */
      Faulty  = AirCon.PayLoadFrame.Parameter[6];
      /* ErrorCounter4 auslesen = Byte7 */
      Counter = AirCon.PayLoadFrame.Parameter[7];

      /* Fehler in ASCII-Text umwandeln */
      Error_to_Ascii(Faulty, Counter, Chr_Error, Chr_Count, Chr_Type);

      SetField(MyForm, F4_FI10 , Chr_Error);
      SetField(MyForm, F4_FI11 , Chr_Count);
      SetField(MyForm, F4_FI12 , Chr_Type);

      /* Fehlerspeicher5 auslesen = Byte8 */
      Faulty  = AirCon.PayLoadFrame.Parameter[8];
      /* ErrorCounter5 auslesen = Byte9 */
      Counter = AirCon.PayLoadFrame.Parameter[9];

      /* Fehler in ASCII-Text umwandeln */
      Error_to_Ascii(Faulty, Counter, Chr_Error, Chr_Count, Chr_Type);

      SetField(MyForm, F4_FI13 , Chr_Error);
      SetField(MyForm, F4_FI14 , Chr_Count);
      SetField(MyForm, F4_FI15 , Chr_Type);

      /* Fehlerspeicher6 auslesen = Byte10 */
      Faulty  = AirCon.PayLoadFrame.Parameter[10];
      /* ErrorCounter6 auslesen = Byte11 */
      Counter = AirCon.PayLoadFrame.Parameter[11];

      /* Fehler in ASCII-Text umwandeln */
      Error_to_Ascii(Faulty, Counter, Chr_Error, Chr_Count, Chr_Type);

      SetField(MyForm, F4_FI16 , Chr_Error);
      SetField(MyForm, F4_FI17 , Chr_Count);
      SetField(MyForm, F4_FI18 , Chr_Type);

      FrmDrawForm(FrmGetFormPtr(MyForm));

      /* Schonmal ein neuen Datensatz anfordern */	   
      kl_Command_ReadError();
    }
    else kl_Command_ReadError();



}


/*******************************************************************/
/* Ausgabe in Frame welcher Knopf am Steuergeraet gedrueckt ist    */
/*******************************************************************/
void do_button_test(unsigned short MyForm)
{ unsigned char Buttons1;
  unsigned char Buttons2;
  unsigned char Buttons3;


  if (  (kl_CommREADY()==TRUE) && 
        (AirCon.PayLoadFrame.Title   == COMMAND_READ_STATUS )
     )
    {
      /* Status Button Status 1 auslesen = Byte5 */
      Buttons1 = AirCon.PayLoadFrame.Parameter[4];

      /* Bit0 = Clima-Button */
      if (Buttons1 & 0x01) SetControl(MyForm,F5_CHK1,1);
      else SetControl(MyForm,F5_CHK1,0);

      /* Bit1 = Check-Button */
      if (Buttons1 & 0x02) SetControl(MyForm,F5_CHK2,1);
      else SetControl(MyForm,F5_CHK2,0);

      /* Bit2 = h-Button */
      if (Buttons1 & 0x04) SetControl(MyForm,F5_CHK3,1);
      else SetControl(MyForm,F5_CHK3,0);

      /* Bit3 = m-Button */
      if (Buttons1 & 0x08) SetControl(MyForm,F5_CHK4,1);
      else SetControl(MyForm,F5_CHK4,0);

      /* Bit4 = Service-Button */
      if (Buttons1 & 0x10) SetControl(MyForm,F5_CHK5,1);
      else SetControl(MyForm,F5_CHK5,0);

      /* Bit5 = FanDown-Button */
      if (Buttons1 & 0x20) SetControl(MyForm,F5_CHK6,1);
      else SetControl(MyForm,F5_CHK6,0);

      /* Bit6 = FanUp-Button */
      if (Buttons1 & 0x40) SetControl(MyForm,F5_CHK7,1);
      else SetControl(MyForm,F5_CHK7,0);

      /* Bit7 = OFF-Button */
      if (Buttons1 & 0x80) SetControl(MyForm,F5_CHK8,1);
      else SetControl(MyForm,F5_CHK8,0);


      /* Status Button Status 2 auslesen = Byte6 */
      Buttons2 = AirCon.PayLoadFrame.Parameter[5];

      /* Bit0 = TempUp-Button */
      if (Buttons2 & 0x01) SetControl(MyForm,F5_CHK9,1);
      else SetControl(MyForm,F5_CHK9,0);

      /* Bit1 = TempDown-Button */
      if (Buttons2 & 0x02) SetControl(MyForm,F5_CHK10,1);
      else SetControl(MyForm,F5_CHK10,0);

      /* Bit2 = AUTO-Button */
      if (Buttons2 & 0x04) SetControl(MyForm,F5_CHK11,1);
      else SetControl(MyForm,F5_CHK11,0);

      /* Bit3 = ECON-Button */
      if (Buttons2 & 0x08) SetControl(MyForm,F5_CHK12,1);
      else SetControl(MyForm,F5_CHK12,0);

      /* Bit4 = Umluft-Button */
      if (Buttons2 & 0x10) SetControl(MyForm,F5_CHK13,1);
      else SetControl(MyForm,F5_CHK13,0);

      /* Bit5 = BiLevel-Button */
      if (Buttons2 & 0x20) SetControl(MyForm,F5_CHK14,1);
      else SetControl(MyForm,F5_CHK14,0);

      /* Bit6 = FLOOR-Button */
      if (Buttons2 & 0x40) SetControl(MyForm,F5_CHK15,1);
      else SetControl(MyForm,F5_CHK15,0);

      /* Bit7 = VENT-Button */
      if (Buttons2 & 0x80) SetControl(MyForm,F5_CHK16,1);
      else SetControl(MyForm,F5_CHK16,0);


      /* Status Button Status 2 auslesen = Byte5 */
      Buttons3 = AirCon.PayLoadFrame.Parameter[6];

      /* Bit0 = Frontscheibe-Button */
      if (Buttons3 & 0x01) SetControl(MyForm,F5_CHK17,1);
      else SetControl(MyForm,F5_CHK17,0);

      /* Bit1 = Heckscheibe-Button */
      if (Buttons3 & 0x02) SetControl(MyForm,F5_CHK18,1);
      else SetControl(MyForm,F5_CHK18,0);

      /* Bit2 = Warnblinker-Button */
      if (Buttons3 & 0x04) SetControl(MyForm,F5_CHK19,1);
      else SetControl(MyForm,F5_CHK19,0);

      

      /* Schonmal ein neuen Datensatz anfordern */	   
      kl_Command_ReadStatus();
    }
    else kl_Command_ReadStatus();



}


/*******************************************************************/
/* Hauptausgabefenster, nach dem Start des Programms sichtbar      */
/*******************************************************************/
void do_mainform(unsigned short MyForm)
{ char buffer[20];



      if (AirCon.Status != Connected) 
	SetField(MyForm, F1_FI1 , "Keine Verbindung");
      else
	SetField(MyForm, F1_FI1 , "Connect!");


      if ((AirCon.Status == Connected) && (AirCon.FrameCounter<10) )
	{
	  /* Seriennummer ausgeben */
	  SetField(MyForm, F1_FI2 , AirCon.SerNum);

	  /* Hardwareversion ausgeben */
	  sprintf(buffer,"%c",AirCon.HW_Version);
	  SetField(MyForm, F1_FI3 , buffer);

	  /* Softwareversion ausgeben */
	  sprintf(buffer,"%c",AirCon.HW_Version);
	  SetField(MyForm, F1_FI4 , buffer);

	  /* Herstellungswoche ausgeben */
	  SetField(MyForm, F1_FI5 , AirCon.Week);

	  /* Herstellungsjahr ausgeben */
	  sprintf(buffer,"199%c",AirCon.Year);
	  SetField(MyForm, F1_FI6 , buffer);

	}

      FrmDrawForm(FrmGetFormPtr(MyForm));


}


/*******************************************************************/
/* Zeigt Parameter aus dem Steuergeraet wie z.b Temperaturen oder  */
/* die Geschwindigkeit an.                                         */
/*******************************************************************/
void do_parameter_read(unsigned short MyForm)
{ char buffer[40];
  FormPtr   form;
    float Daten;
    unsigned short Dat16;

  if (  (kl_CommREADY()==TRUE) && 
        (AirCon.PayLoadFrame.Title   == COMMAND_READ_PARAM )
     )
    {
     form = FrmGetActiveForm();
     switch(AirCon.LastParam)
      {
      case PARAM_AIR1:
	/* Daten umrechen */
         Daten=AirCon.PayLoadFrame.Parameter[0];
	 Daten=Daten/2 -40;
         /* Palmpilot kann kein Float umrechen, also hier etwas tricky */
         /* eine Nachkommastelle anzeigen */
	 StrPrintF(buffer, "%d.%d Grad", (int) Daten, (int) (Daten * 10.0) % 10);
	 /*	 StrPrintF(temp, "%d.%02d", (int) Daten, (int) (Daten * 100.0) % 100); */
         /* Ausgabe ins Label, Achtung buffer darf nicht laenger als der */
         /* Defaultstring im Resourcenfile sein!                         */
         FrmCopyLabel(form,F6L1,buffer);
	break;

      case PARAM_AIR2:
         Daten=AirCon.PayLoadFrame.Parameter[0];
	 Daten=Daten/2 -40;
	 StrPrintF(buffer, "%d.%d Grad", (int) Daten, (int) (Daten * 10.0) % 10);
         FrmCopyLabel(form,F6L2,buffer);
	break;

      case PARAM_EXAIR:
         Daten=AirCon.PayLoadFrame.Parameter[0];
	 Daten=Daten/2 -40;
	 StrPrintF(buffer, "%d.%d Grad", (int) Daten, (int) (Daten * 10.0) % 10);
         FrmCopyLabel(form,F6L3,buffer);
	break;

      case PARAM_PASSAIR:
         Daten=AirCon.PayLoadFrame.Parameter[0];
	 Daten=Daten/2 -40;
	 StrPrintF(buffer, "%d.%d Grad", (int) Daten, (int) (Daten * 10.0) % 10);
         FrmCopyLabel(form,F6L4,buffer);
	break;

      case PARAM_DISTPOT:
	 StrPrintF(buffer, "%d", (int) AirCon.PayLoadFrame.Parameter[0]);
         FrmCopyLabel(form,F6L5,buffer);
	break;

      case PARAM_MIXPOT:
	 StrPrintF(buffer, "%d", (int) AirCon.PayLoadFrame.Parameter[0]);
         FrmCopyLabel(form,F6L6,buffer);
	break;

      case PARAM_FAN:
	Dat16=AirCon.PayLoadFrame.Parameter[0];
	Dat16=Dat16*256+AirCon.PayLoadFrame.Parameter[1];
	 StrPrintF(buffer, "%d", Dat16);
         FrmCopyLabel(form,F6L7,buffer);
	break;

      case PARAM_SPEED:
	 StrPrintF(buffer, "%dkm/h", (int) AirCon.PayLoadFrame.Parameter[0]);
         FrmCopyLabel(form,F6L8,buffer);
	break;

      case PARAM_SUN:
	 StrPrintF(buffer, "%duA", (int) AirCon.PayLoadFrame.Parameter[0]*2);
         FrmCopyLabel(form,F6L9,buffer);
	break;

      };

    AirCon.LastParam=PARAM_READY;
    FrmDrawForm(FrmGetFormPtr(MyForm));

    }

}


/*******************************************************************/
/* Erlaubt es Aktoren wie z.b Lueftermore oder Klappen zu steuern  */
/* Das funktioniert nur wenn sich das Steuergeraet in einem        */
/* besonderen Diagnosemodus befindet.                              */
/*******************************************************************/
void do_parameter_write(unsigned short MyForm)
{ 

  if ( AirCon.Active_Diag ==FALSE)
    {
      /* Wir sind derzeit nicht im Aktive-Modus, das muessen */
      /* wir aber aendern fuer die Sonderbefehle die wir     */
      /* verwenden wollen.                                   */

      if (kl_CommREADY()==TRUE) 
      {
        /* Okay, die Schnittstelle ist bereit */           
        
	if (AirCon.PayLoadFrame.Title   == COMMAND_SET_DIAG )
	  {
	    /* Steuergeraet hat Befehl akzeptiert und ist nun */
	    /* im Aktivemode.                                 */
	    AirCon.Active_Diag = TRUE;
	    /*
	    work das muessen wir hier noch irgendwie im Frame anzeigen!
            vielleicht mit einem kleinen Radiobutton.
	    */
	  }
	else
	  {
	    /* Wir muessen jetzt das Steuergeraet in den Aktivemode */
            /* versetzen                                            */
	    kl_Command_Set_Diagmode();
	    return;
	  };
     
      }; /* kl_CommREADY()==TRUE */
    }  /* ( AirCon.Active_Diag ==FALSE) */
  else
    {
      /* Wir sind im Aktivemode */
      if (  (kl_CommREADY()==TRUE) && 
	    (AirCon.PayLoadFrame.Title   == COMMAND_SET_ACTUATOR )
	 )
	{
	  /* Okay, jetzt kam die Antwort auf einen Aktuator-Befehl */



	}

    };

}

/*******************************************************************/
/* Diese Funktion wird mehrmals pro Sekunde aufgerufen und sorgt   */
/* dafuer das der Inhalt des aktuellen Frames mit Daten vom        */
/* vom Steuergeraet gefuellt wird.                                 */
/*******************************************************************/
void Frame_Work(FormPtr AktiveForm)
{ unsigned short Fenster;

 Fenster = AktiveForm->formId;

  switch(Fenster)
    {
    case MainFormID:
      do_mainform(Fenster);
      break;

    case Form2ID:
      if (AirCon.Status != Connected) return;
      do_status1_test(Fenster);
      break;

    case Form3ID:
      if (AirCon.Status != Connected) return;
      do_status2_test(Fenster);
      break;

    case Form4ID:
      if (AirCon.Status != Connected) return;
      do_error_show(Fenster);
      break;
      
    case Form5ID:
      if (AirCon.Status != Connected) return;
      do_button_test(Fenster);
      break;

    case Form6ID:
      if (AirCon.Status != Connected) return;
      do_parameter_read(Fenster);
      break;

    case Form7ID:
      if (AirCon.Status != Connected) return; 
      do_parameter_write(Fenster);
      break;


    }

}

/*******************************************************************/
/* Allgemeine Initialisierungsaufgaben welche nur einmal beim      */
/* start des Programms notwendig sind                              */
/*******************************************************************/
void SystemInitialisation(void)
{
  FormPtr   form;

  form = FrmGetActiveForm();  /* Aktiven Formpointer holen */

  kl_init();  /* KL-Businterface initialisieren */

}


/*******************************************************************/
/* Hier wird geprueft welches Event eingetreten ist und die        */
/* zugehoerige Funktion aufgerufen                                 */
/* Es handelt sich dabei um eine Endlosschleife die das System     */
/* immer wieder nach neuen Ereignissen fragt und solange laeuft    */
/* bis sie sich entschliesst die Kontrolle an das System zurueck   */
/* zugeben. Dies kann entweder durch das Programm selbst geschehen */
/* oder auch durch ein appStopEvent von aussen. Letzeres passiert  */
/* z.B wenn der User ein anderes Programm startet. In diesem Fall  */
/* muss sich dieses Programm gezielt beenden oder Pilot haengt     */
/*******************************************************************/
int Eventloop()
{
  EventType e;   /* Da sagt uns das System was passiert ist */ 
  short err;     /* Fuer private Fehlermeldungen            */
  char Null_Counter=5;
  int test;
  char dummy[40];
  int DoWin;

  DoWin=TRUE;

    while(1) {          /* Dies ist ein endlos laufender Kommandoparser */


         /* Kommando bzw. Ereignis vom System holen */
         /* Dabei gibt der zweite Parameter eine Zeit an in der auf jedenfall */
         /* ein Event erfolgen muss, und zwar SysTicksPerSecond, das sollten  */
         /* also 1/100Sekunden sein. */ 
	 EvtGetEvent(&e, 10); 

         /* Systemkommandos ignorieren wir, wuerden wir das nicht tun */
         /* koennte der Palm nicht weiterlaufen, es waere also z.B    */
         /* nicht mehr moeglich dieses Programm zu beenden oder ein   */
         /* anderes zu starten.                                       */
         if (SysHandleEvent(&e)) continue;  

         /* Auch Menuekommandos werden ignoriert damit der Pilot        */
	 /* weiterlaeuft, sonst wuerde er naemlich nicht mehr erkennen  */ 
         /* welcher Menuepunkt ausgewaehlt wuerde!                      */
         if (MenuHandleEvent((void *)0, &e, &err)) continue; 

 

	 /* Jetzt kann es sich eigentlich nur noch um ein Ereignis     */
         /* wie z.B ein Tastendruck oder ein Stiftdruck handeln        */
         /* Wir muessen also genau nachschauen ob was dabei ist auf    */
         /* das wir reagieren wollen!                                  */

         switch (e.eType) {

	 case winExitEvent:
	   DoWin = FALSE;
	   break;

	 case winEnterEvent:
	   DoWin = TRUE;
	   break;

	   /* Das ist der Nullevent. Der kommt immer wenn die          */
	   /* eingestellten Ticks bei EvtGetEvent abgelaufen sind      */
           /* Mit anderen worten, diese Funktion wird alle 150ms       */
           /* aufgerufen                                               */
	 case nilEvent:
	   if (Null_Counter == 0) 
	     {
	       /* Das hier ist leider ein Problem.             */
               /* In diesem Programmteil wird der aktuelle     */
               /* Bildschirm upgedatet, und das geschieht auch */
               /* wenn wir die Menuezeile am oberen Bildschirm */
               /* rand offen haben und dann wird die leider    */
               /* ueberschrieben!                              */

	       if (DoWin==TRUE) 
		 if (MenuGetActiveMenu() == NULL) Frame_Work( FrmGetActiveForm() );
	       Null_Counter = 5;
	     }
	   else Null_Counter--;
 
           /* Datenaustausch mit dem Steuergeraet, muss immer stattfinden! */
	   kl_Frame_exchange();
	   break;

            /* Wird jedesmal aufgerufen wenn das Programm erneut geladen  */
 	    /* wurde. Also z.B wenn das Programm das erstemal ueberhaubt  */
 	    /* aufgerufen wurde. Oder aber wenn das Programm nach einem   */
 	    /* anderem Programm aufgerufen wurde. Aber nicht wenn das     */
	    /* Programm zweimal nacheinander aufgerufen wird!             */
            case frmLoadEvent:
               FrmSetActiveForm(FrmInitForm(e.data.frmLoad.formID));

	       /* OpenRS232 oeffnet die Schnittstelle nur wenn sie nicht */
               /* bereits durch OpenRS232 geoeffnet wurde                */
               /* So ist es moeglich das diese Funktion bei jedem Form-  */
               /* wechsel erneut aufgerufen wird                         */
	       if (OpenRS232()==FALSE) return(0); 
               break;


            /* Ein Form wurde geoeffnet. Das ist zum Beispiel    */
	    /* beim Start des Programms der Fall, aber auch wenn */
            /* ein Programm aus mehreren Forms besteht und       */
            /* zwischen ihnen umgeschaltet wird.                 */
            /* Laesst sich daher nur fuer Initialisierungen      */
            /* verwenden wenn das Programm nur aus einem einzigen*/
            /* Form besteht!                                     */
            case frmOpenEvent:
 	       FrmDrawForm(FrmGetActiveForm());  /* Hauptfenster zeichnen */
	       /*	       SystemInitialisation(); */
               break;




            /* Es wurde ein Eintrag in der Menuzeile des aktiven Forms */
	    /* ausgewaehlt.                                            */
            case menuEvent:
	      switch (e.data.menu.itemID)
		{

		  /* Connect-Frame, das ist der Hauptframe beim start  */
                  /* des Programs, hier wird die Verbindung zum        */
                  /* Steuergeraet hergestellt und Informationen ueber  */
                  /* das Steuergeraet selber ausgegeben                */
		case MenuItem1:
	  	  FrmGotoForm(MainFormID);  
		  break;

		  /* Status-Frame: Allgemeine Statusinformationen aus */
                  /* aus dem Steuergeraet                             */
		case MenuItem2:
	  	  if (AirCon.Status == Connected) FrmGotoForm(Form2ID);  
		  else        FrmAlert(AlertID_NO_CONNECT);     
		  break;

		  /* Status2-Frame */
		case MenuItem3:
	  	  if (AirCon.Status == Connected) FrmGotoForm(Form3ID);  
		  else        FrmAlert(AlertID_NO_CONNECT);     
		  break;


		  /* Error-Frame: Zeigt im Steuergeraet abgelegte     */
                  /* FEhler an und erlaubt es sie zu loeschen         */
		case MenuItem4:
	  	  if (AirCon.Status == Connected) FrmGotoForm(Form4ID);  
		  else        FrmAlert(AlertID_NO_CONNECT);     
		  break;

		  /* Button-Frame: Zeigt an welche Tasten am         */
                  /* Steuergeraet gedrueckt werden                   */
		case MenuItem5:
	  	    if (AirCon.Status == Connected) FrmGotoForm(Form5ID);  
		    else        FrmAlert(AlertID_NO_CONNECT);     
		  break;

		  /* Parameter-Read: Zeigt Temperaturen und die Geschwindigkeit an   */
		case MenuItem6:
       	  	    if (AirCon.Status == Connected) FrmGotoForm(Form6ID);  
		    else        FrmAlert(AlertID_NO_CONNECT); 
		  break;

		  /* Parameter-Write: Piepser und Luefter einschalten    */
		case MenuItem7:
	  	    if (AirCon.Status == Connected)  FrmGotoForm(Form7ID);  
	       	    else        FrmAlert(AlertID_NO_CONNECT);   
		  break;


		  /* Es wurde Quit ausgewaehlt und das Programm beendet sich */
		case MenuItemQuit:
		  CloseRS232();
		  return(0);
		  break;

		}

               break;




            /* Es wurde ein Button angewaehlt */ 
	    case ctlSelectEvent:
	        if (ButtonCheck(e.data.ctlEnter.controlID)==FALSE) return(0);
            break;





	       /* Programm wurde angehalten z.B weil der User ein anderes */
	       /* Programm gestartet hat */
            case appStopEvent:

	       /* Wir haben nichts anderes zutun ausser den RS232-Port    */
	       /* zu schliessen. Das bedeutet aber auch das er vorher     */
	       /* die ganze Zeit offen war, auch wenn das Programm darauf */
	       /* wartete das der User irgendetwas macht. Dies ist        */
	       /* problematisch da der Pegelwandler am Port die ganze     */
	       /* Zeit eingeschaltet bleibt und dabei viel Strom          */
	       /* verbraucht!                                             */
	       /* Das laesst sich aber leider nicht vermeiden da das      */
               /* staendig Daten mit dem Steuergeraet austauschen muss    */
               /* damit das Steuergeraet auch im Diagnosemodus bleibt.    */
	      CloseRS232();

	      return(0); /* Damit entfernen wir uns aus der Liste der   */
	                 /* vom System mit Events beglueckten Programme */


	       /* Es ist ein Ereignis eingetreten das wir nicht bearbeiten*/
	       /* koennen, also geben wir dies ans System zurueck.        */  
               /* Das ist sehr wichtig sonst laufen die anderen Programme */
               /* nicht mehr richtig da sie nie mehr aufgerufen werden    */
            default:
                if (FrmGetActiveForm()) FrmHandleEvent(FrmGetActiveForm(), &e);
	 }

    } 

};





/********************************************************************/
/* Hauptprogramm                                                    */
/********************************************************************/
DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
  DWord Adress;
  volatile unsigned char *Adresspointer;
  unsigned char dummy;
  short AktiveForm = FormFirst;

  /* Wir reagieren nur auf Events vom System! Nicht auf Nachrichten */
  /* welche Programme auch untereinander austauschen koennen        */
  if (!cmd) {

       /* Hauptbildschirm anmelden und zeichen                       */
       /* Das genaue aussehen dieses Bildschirms wird dabei im       */
       /* externen Resourcenfile beschrieben                         */ 
       FrmGotoForm(MainFormID); 

       return(Eventloop());



  }
}















