/* Hier werden die Register des Dragonballs definiert */

#define BYTEREG(data)  (*(volatile Byte*)  data)
#define WORDREG(data)  (*(volatile Word*)  data)
#define LONGREG(data)  (*(volatile DWord*) data)

#define PEDIR       BYTEREG(0xfffff420)
#define PEDATA      BYTEREG(0xfffff421)
#define PEUP        BYTEREG(0xfffff422)
#define PESEL       BYTEREG(0xfffff423)

#define PJDIR       BYTEREG(0xfffff438)
#define PJDATA      BYTEREG(0xfffff439)
#define PJPUEN      BYTEREG(0xfffff43a) 
#define PJSEL       BYTEREG(0xfffff43b)

#define PORTE       LONGREG(0xfffff420)
#define PORTJ       LONGREG(0xfffff438)

/* interrupt mask register */
#define IMR  LONGREG(0xfffff304)

#define USTCNT    WORDREG(0xfffff900) /* UART Status/Control Register */
#define UBAUD     WORDREG(0xfffff902) /* UART Baud Control Register */
#define URX       WORDREG(0xfffff904) /* UART RX Register */
#define UTX       WORDREG(0xfffff906) /* UART TX Register */
#define UTXH      BYTEREG(0xfffff906) /* UART TX Register */
#define UMISC     WORDREG(0xfffff908) /* UART Misc Register */
#define UMISCL    BYTEREG(0xfffff909) /* UART Misc Register */

#define PKTEST1    WORDREG(0xfffff440)
#define PKTEST2    WORDREG(0xfffff442)

#define PKDIR     BYTEREG(0xfffff440) /* Port K Direction Register */
#define PKDATA    BYTEREG(0xfffff441) /* Port K Dir und DATA */
#define PKPUEN    BYTEREG(0xfffff442) /* Port K Pullup Enable Register */
#define PKSEL     BYTEREG(0xfffff443) /* Port K Select Register */

#define PGDIR     BYTEREG(0xfffff430) /* Port G Direction Register */
#define PGDATA    BYTEREG(0xfffff431) /* Port G Data Register */
#define PGPUEN    BYTEREG(0xfffff432) /* Port G Pullup Enable Register */
#define PGSEL     BYTEREG(0xfffff433) /* Port G Select Register */

#define PMDIR     BYTEREG(0xfffff448) /* Port M Direction Register 1=output! */
#define PMDATA    BYTEREG(0xfffff449) /* Port M Data Register */
#define PMPUEN    BYTEREG(0xfffff44A) /* Port M Pullup Enable 1=pullup on*/
#define PMSEL     BYTEREG(0xfffff44B) /* Port M Select Register 1=io-mode */



